var fs = require('fs');
var http = require('http');
var path = require('path');
const axios = require('axios');
var request = require('request');
const FormData = require('form-data');
const bodyParser = require('body-parser');

// var https = require('https');

// var credentials = {
//   key: fs.readFileSync('/home/winpars/public_html/SSL/ssl.key'),
//   cert: fs.readFileSync('/home/winpars/public_html/SSL/ssl.pem')
// };
var express = require('express');
const compression = require('compression');
const zlib = require('zlib');
const cjson = require('compressed-json')
var app = express();
app.use(bodyParser.urlencoded({ extended: true }));
app.use(compression({
  level:6,
  threshold:2*1000,
  filter:(req,res)=>{
    if (req.headers['x-no-compression']) {
      return false;
    }
    return compression.filter(req, res);
  }
}));

// const shouldCompress = (req, res) => {
//   if (req.headers['x-no-compression']) {
//     // Will not compress responses, if this header is present
//     return false;
//   }
//   // Resort to standard compression
//   return compression.filter(req, res);
// };
// app.use(compression({
//   // filter: Decide if the answer should be compressed or not,
//   // depending on the 'shouldCompress' function above
//   filter: shouldCompress,
//   level:9,
//   // threshold: It is the byte threshold for the response
//   // body size before considering compression, the default is 1 kB
//   threshold: 0
// }));
// app.configure(function(){
//
//   app.use(express.compress());
// });


var redis = require('redis');
var client = redis.createClient();
var MongoClient = require('mongodb').MongoClient;
var url = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/admin";
const mongoose = require("mongoose");
mongoose.set('strictQuery', false)
//const clusterURI = "mongodb+srv://mongouser:dbZCiED9F65gAbKc@cluster0.otpkk.mongodb.net/winpars_db?retryWrites=true&w=majority";
const clusterURI = "mongodb+srv://winpars:6FA6gPp7CRyFQ028@cluster1.2aesn.mongodb.net/winpars_db?retryWrites=true&w=majority";
const localURI = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/winpars_db";
const betradereachpush = require('./models/Betradereachpush')
const betraderresults = require('./models/Betraderresults')
const subsriptionTable = require('./models/SubsriptionTable')
mongoose.connect(localURI).then(()=>{
    console.log("Connection done");
}).catch((err)=>{
    console.log(err);
})
// your express configuration here
async function removed_finish_match(finalData) {
  // MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  //     if (err) throw err;
  //     var dbo = db.db("winpars_db");
  //     var myquery = { eventId: finalData.eventId.toString()  };
  //     // var newvalues = { $set: finalData };
  //     // var myquery = { address: 'Mountain 21' };
  //     dbo.collection("betradereachpush").deleteOne(myquery, function(err, obj) {
  //         if (err) throw err;
  //         // console.log("1 document deleted");
  //         db.close();
  //     });
  //   });
  var myquery = { eventId: finalData.eventId.toString()  };
  let response = await betradereachpush.deleteOne(myquery);
}
var httpsServer = http.createServer(app);
// var httpsServer = https.createServer(credentials, app);

// httpServer.listen(8080);
// httpsServer.listen(8443);
//
process.env['NODE_TLS_REJECT_UNAUTHORIZED'] = '0';
var port    = process.env.PORT || 5003;
httpsServer.listen(port, '185.80.54.5', function () {
  console.log('Server listening at port %d', port);
  // res.send("Welcome to Winpars");
});
let allowmarkets;
let betraderleague_sort;
let cancel_league;
let blocked_league;
client.get('blocked_league', function(err, reply) {
  blocked_league = reply; // ReactJS
});
client.get('betrader_market_id_list', function(err, reply) {
  allowmarkets = reply; // ReactJS
});
client.get('betraderleague_sort', function(err, reply) {
  betraderleague_sort = reply; // ReactJS
});
client.get('cancel_league', function(err, reply) {
  cancel_league = reply; // ReactJS
});
Array.prototype.removeItem = function(a) {
    for (i = 0; i < this.length; i++) {
        if (this[i] == a) {
            for (i2 = i; i2 < this.length - 1; i2++) {
                this[i2] = this[i2 + 1];
            }
            this.length = this.length - 1
            return;
        }
    }
}
function get_main_odds(info,odds) {
  let demo_participents = new Array();
  if(info.sport=="Football"){
    let oddsflag = 0;
    //1777
    let oddslenth = 0;
    if(odds){
      oddslenth  = odds.length;
      for (var i = 0; i < odds.length; i++) {
        if(odds[i].id=="1777"){
          oddsflag = 1;
          return {"participants":odds[i].participants,"id":odds[i].id,"short_name":odds[i].short_name,"ttlods":odds.length};
        }
      }
    }

    if(oddsflag==0){
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
        return {"participants":demo_participents,"id":"1777","short_name":"","totalodds":oddslenth,"ttlods":1};
    }
  }
  if(info.sport=="Tennis"){
    let oddsflag = 0;
    // 1763
    let oddslenth = 0;
    if(odds){
      oddslenth  = odds.length;
    for (var i = 0; i < odds.length; i++) {
      if(odds[i].id=="1763"){
          oddsflag = 1;
        return {"participants":odds[i].participants,"id":odds[i].id,"short_name":odds[i].short_name,"ttlods":odds.length};
      }
    }
  }
    if(oddsflag==0){
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      // demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
        return {"participants":demo_participents,"id":"1763","short_name":"","totalodds":oddslenth,"ttlods":0};
    }
  }
  if(info.sport=="Basketball"){
    let oddsflag = 0;
    //180032
    let oddslenth = 0;
    if(odds){
      oddslenth  = odds.length;
    for (var i = 0; i < odds.length; i++) {
      if(odds[i].id=="180032"){
          oddsflag = 1;
      return {"participants":odds[i].participants,"id":odds[i].id,"short_name":odds[i].short_name,"ttlods":odds.length};
      }
    }
  }
    if(oddsflag==0){
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      // demo_participents.push({"v":"","short_name":"-","value_euttlods
        return {"participants":demo_participents,"id":"180032","short_name":"","totalodds":oddslenth,"ttlods":1};
    }
  }
  if(info.sport=="Volleyball"){
    let oddsflag = 0;
    //910080
    let oddslenth = 0;
    if(odds){
      oddslenth  = odds.length;
    for (var i = 0; i < odds.length; i++) {
      if(odds[i].id=="910080"){
          oddsflag = 1;
        return {"participants":odds[i].participants,"id":odds[i].id,"short_name":odds[i].short_name,"ttlods":odds.length};
      }
    }
  }
    if(oddsflag==0){
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
      // demo_participents.push({"v":"","short_name":"-","value_eu":"-"});
        return {"participants":demo_participents,"id":"910080","short_name":"","totalodds":oddslenth,"ttlods":1};
    }
  }
}
function find_match_list(leagueName,feedset) {
    let matchinfo = new Array();
    for (var i = 0; i < feedset.length; i++) {
      if(feedset[i].match.info.league==leagueName){
        // feedset[i].match.core.blocked = 1;
        let timenow = Math.floor(Date.now()/1000);
        let updated_ts = feedset[i].match.core.updated_ts;
        let diff = (updated_ts - timenow)/60;
        diff = Math.abs(diff);
        if(diff>=30){
          let finishedMatch = {"eventId":feedset[i].match.info.id};
          removed_finish_match(finishedMatch);
        }
        feedset[i].match.info.blocked = feedset[i].match.core.blocked;
          feedset[i].match.info.diff =diff;
        feedset[i].match.info.bc = feedset[i].match.core.blocked==1?'ResultContant':0;
        if(feedset[i].match.info.minute<0){
          feedset[i].match.info.minute = 0;
        }
        matchinfo.push({"info":feedset[i].match.info,"odds":get_main_odds(feedset[i].match.info,feedset[i].match.odds)});

        if(feedset[i].match.info.period=="Finished"){
          let finishedMatch = {"eventId":feedset[i].match.info.id};
          removed_finish_match(finishedMatch);
        }

      }

    }
    return matchinfo;
}
function getSportsName(id) {
  if(id==1){
    return "Football";
  }
  if(id==18){
    return "Basketball";
  }
  if(id==13){
    return "Tennis";

  }
  if(id==91){
    return "Volleyball";
  }
}
function geticonName(id) {
  if(id==1){
    return "Foo";
  }
  if(id==18){
    return "Bas";
  }
  if(id==13){
    return "Ten";

  }
  if(id==91){
    return "Vol";
  }
}
function getLeagueSortNo(leaguename) {
  let sort_order = leaguename;
  let parse = JSON.parse(betraderleague_sort);
  for(k in parse){
    if(k==leaguename){
      sort_order = parse[k];
    }
  }
    return sort_order;
}
function manage_before_out(feed){
  // client.get('cancel_league', function(err, reply) {
  //   cancel_league = reply; // ReactJS
  // });
    let numberLeague = new Array();
    let nonumberLeague = new Array();
    let finalLeagues = new Array();
    for (var i = 0; i < feed.length; i++) {
      if(!isNaN(feed[i].sort)){
        numberLeague.push(feed[i]);
      }else{
        nonumberLeague.push(feed[i]);
      }

    }

    for (var i = 0; i < numberLeague.length; i++) {
        for (var j = i+1; j < numberLeague.length; j++) {
            if(parseInt(numberLeague[i].sort)>parseInt(numberLeague[j].sort)){
              temp = numberLeague[i];
              numberLeague[i] = numberLeague[j];
              numberLeague[j] = temp;
            }
        }
    }

      nonumberLeague.sort(function (a, b) {
    return a.sort.localeCompare(b.sort); //using String.prototype.localCompare()
    });



    for (var i = 0; i < numberLeague.length; i++) {
      // if(is_cancel_league(numberLeague[i].leagueName)){
        finalLeagues.push(numberLeague[i]);
      // }

    }
    for (var i = 0; i < nonumberLeague.length; i++) {
        // if(is_cancel_league(nonumberLeague[i].leagueName)){
      finalLeagues.push(nonumberLeague[i]);
    // }
    }


    return finalLeagues;
}
function is_cancel_league(leagueName) {
  let flag = 1;
    cancel_league_ob = JSON.parse(cancel_league);
    for(i in cancel_league_ob){
      if(leagueName==cancel_league_ob[i]){
        flag = 0;
      }
    }
  return 1;
}
function weekend_allow(info) {
  let day = new Date().toLocaleString('en-US', {
        weekday: 'long'})
  let blocked_league_ob = JSON.parse(blocked_league);
  let flag = 1;
  for(i in blocked_league_ob){
    if(info.lid==blocked_league_ob[i]){
      flag = 0;
    }
  }

  if(day!="Saturday" || day!="Sunday"){
      if(flag==0){
        flag = 1;
      }
  }
  return 1;
}
function process_feed_to_exports_sports(result,sp) {
  let update_ts = Math.floor(Date.now()/1000);
  let feed = new Array();
  let uniqueleague = new Array();
  for (var i = 0; i < result.length; i++) {
    if(!result[i].match.info.name.includes("esports") && !result[i].match.info.name.includes("Reserves") && !uniqueleague.includes(result[i].match.info.league) && is_cancel_league(result[i].match.info.league) && weekend_allow(result[i].match.info)){
      let matchlist = find_match_list(result[i].match.info.league,result);
      feed.push({"leagueName":result[i].match.info.league,"matchlist":matchlist,"flag":matchlist[0].info.flag,"sort":getLeagueSortNo(result[i].match.info.league)});
      uniqueleague.push(result[i].match.info.league);
    }


  }
    let sport = getSportsName(sp);
    let leaguelist = {"events":manage_before_out(feed),"sport":sport,"iconame":geticonName(sp),"text":sport};
    // let compressed = cjson.compress(leaguelist)
    leaguelist = JSON.stringify(leaguelist);
    makepostreqviareqlib(leaguelist,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',sport+".json")
    makepostreqviareqlibfordemo(leaguelist,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',sport+".json")
    // fs.writeFile(sport+".json", leaguelist, 'utf8', function (err) {
    //     if (err) {
    //         // console.log("An error occured while writing JSON Object to File.");
    //         return console.log(err);
    //     }
    //
    //       console.log(sport+ " Files Saved");
    // });
}
function makepostreqviareqlibfordemo(content,url,fn) {
//   let payload = { content: content, fn: fn };
//   urlnew = 'http://185.80.53.53:3000'
//   request.post(
//     urlnew,
//       {json:payload},
//         function (error, response, body) {
//             if (!error && response.statusCode == 200) {
//                 console.log(body);
//             }else{
//                 // console.log(error)
//             }
            
//         }
//     );
}
function makepostreqviareqlib(content,url,fn) {
  let payload = { content: content, fn: fn };
  urlnew = 'http://193.42.38.211:3000'
  request.post(
    urlnew,
      {json:payload},
        function (error, response, body) {
            if (!error && response.statusCode == 200) {
                console.log('Demosite:'+body);
                console.log(fn)
            }else{
                // console.log(error)
            }
            
        }
    );
}
async function makepostreq(content,url,fn) {
  // const form_data = new FormData();
  // form_data.append('d', content);
  // form_data.append('fn', fn);
  // form_data.append('item',item);
  // let payload = { content: content, fn: fn };
  //   let res = await axios.post(url, payload);
  //
  //   let data = res.data;
  //   console.log(data);
}
function process_feed_new(result,req,res) {

    let update_ts = Math.floor(Date.now()/1000);
    let feed = new Array();
    let uniqueleague = new Array();
    for (var i = 0; i < result.length; i++) {
      if(!uniqueleague.includes(result[i].match.info.league) && is_cancel_league(result[i].match.info.league)){
        let matchlist = find_match_list(result[i].match.info.league,result);
        feed.push({"leagueName":result[i].match.info.league,"matchlist":matchlist,"flag":matchlist[0].info.flag,"sort":getLeagueSortNo(result[i].match.info.league)});
        uniqueleague.push(result[i].match.info.league);
      }


    }

      let leaguelist = {"events":manage_before_out(feed),"sport":getSportsName(req.query.sports),"iconame":geticonName(req.query.sports),"text":getSportsName(req.query.sports)};
      // let compressed = cjson.compress(leaguelist)
      res.send(leaguelist);
    //   res.writeHead(200, { 'content-encoding': 'gzip' });
    // res.pipe(zlib.createGzip()).pipe(leaguelist);
}
function modify_markets(req,res,odds) {
  if(!odds){
    let markets = {};
    return markets;
  }
  let min_data = { "0":"00:00-09:59",
                "00":"00:00-09:59",
                "10":"10:00-19:59",
                "20":"20:00-29:59",
                "30":"30:00-39:59",
                "40":"40:00-49:59",
                "50":"50:00-59:59",
                "60":"60:00-69:59",
                "70":"70:00-79:59",
                "80":"80:00-89:59"};


    let markets = {};
    for (var i = 0; i < odds.length; i++) {
      if(markets.hasOwnProperty(odds[i].id)){
        // markets[result[i].id] = new Array();
        markets[odds[i].id].push(i);
      }else{
        markets[odds[i].id] = new Array();
        markets[odds[i].id].push(i);
      }

    }

    for (var i = 0; i < odds.length; i++) {
        if(odds[i].id=="50166BK"){
          for (var j = 0; j < odds[i].participants.length; j++) {
            let name = odds[i].participants[j].name.split(" ");
            odds[i].participants[j].name = name[0];
            odds[i].participants[j].short_name = name[0];
            odds[i].participants[j].handicap = name[1];

          }
          odds[i].short_name = odds[i].short_name +" - "+  min_data[odds[i].handicap];
          odds[i].name = odds[i].short_name;
        }
        if(odds[i].id=="50166"){
          for (var j = 0; j < odds[i].participants.length; j++) {
            let name = odds[i].participants[j].name.split(" ");
            odds[i].participants[j].name = name[0];
            odds[i].participants[j].short_name = name[0];
            odds[i].participants[j].handicap = name[2];
            // odds[i].participants[j].tt = name;

          }
          odds[i].short_name = odds[i].short_name +" - "+  min_data[odds[i].ha];
          odds[i].name = odds[i].short_name;
        }
        if(odds[i].id=="10159" || odds[i].id=="50346"){
            if(odds[i].participants[0].handicap>0){

              if(odds[i].participants[1]){
                odds[i].participants[1].handicap = -odds[i].participants[1].handicap;
              }
              if(odds[i].participants[2]){
                odds[i].participants[2].handicap = -odds[i].participants[2].handicap;
              }

            }
            if(odds[i].participants[0].handicap<0){
              if(odds[i].participants[1]){
                odds[i].participants[1].handicap = Math.abs(odds[i].participants[1].handicap);
              }
              if(odds[i].participants[2]){
                odds[i].participants[2].handicap = Math.abs(odds[i].participants[2].handicap);
              }

            }
        }
        if(odds[i].id=="10126"){
          let handi_score = odds[i].ha;
          let nth_goal="";
          if(handi_score==1){
            nth_goal = "1st Goal";
          }
          else if(handi_score==2){
              nth_goal = "2nd Goal";
          }
          else if(handi_score==3){
              nth_goal = "3rd Goal";
          }
          else{
              nth_goal = handi_score+"th Goal";
          }

            odds[i].short_name = odds[i].short_name +"("+nth_goal+")";
            odds[i].name = odds[i].name +"("+nth_goal+")";
        }


        if(odds[i].id=="50397" || odds[i].id=="50396"){
        for (var j = 0; j < odds[i].participants.length; j++) {
            if(odds[i].participants[j].name=="Home"){
              odds[i].participants[j].name  = 1;
              odds[i].participants[j].short_name = 1;
            }
            if(odds[i].participants[j].name=="Away"){
              odds[i].participants[j].name  = 2;
              odds[i].participants[j].short_name = 2;
            }
          }
        }

        let marketlist = new Array(10170,10147,1446,180061,180079,180088,180097,180106,9100831,910097,9100832,9100833,9100834,9100835,9100836,9100837,130082,1302041,1302042,1302043,1302044,1302045);
        if(marketlist.includes(odds[i].id)){
          if(odds[i].participants[0].handicap>0){
            odds[i].participants[1].handicap = -odds[i].participants[1].handicap;

          }
          if(odds[i].participants[0].handicap<0){
            odds[i].participants[1].handicap = Math.abs(odds[i].participants[1].handicap);

          }
        }

    }
    // for (var i = 0; i < markets.length; i++) {
    // markets.forEach((item, i) => {
    //   //market array which have market id with id list
    //     if(markets[i].length>1){
    //       let mainIndex = markets[i][0];
    //       for (var j= 1; j < markets[i].length-1; j++) {
    //         for(var k=0;k<odds[markets[i][j]].participants.length;k++){
    //           odds[mainIndex].participants.push(odds[markets[i][j]].participants[k]);
    //         }
    //             odds.splice(markets[i][j],1);
    //       }
    //
    //     }
    // });
    let mainIndex;
    foreach(markets,(i, item) => {
      //market array which have market id with id list

        if(item.length>1){
          mainIndex  = item[0];
           // item.splice(0,1);
           delete item[0];
           for (var j = 1; j < item.length; j++) {
             for (var k = 0; k < odds[item[j]].participants.length; k++) {
                 odds[mainIndex].participants.push(odds[item[j]].participants[k]);
             }

              // odds.splice(item[j],1);
              delete odds[item[j]];
           }
        }
    });
    let newodds = new Array();
    // foreach(odds,(i, item) => {
    //         // if(!Array.isArray(item)){
    //         newodds.push(i);
    //       // }
    //   });
    // for (var i = 0; i < odds.length; i++) {
    //   if(odds[i] instanceof Array){
    //       newodds.push(odds[i]);
    //   }
    //
    // }

    for(let i of odds){
      i && newodds.push(i);
    }
    for (var i = 0; i < newodds.length; i++) {
      delete newodds[i].o;
    }
    let newoddsupdated = new Array();
    for (var i = 0; i < newodds.length; i++) {
    //   if(allowmarkets.includes(newodds[i].id)){
        newoddsupdated.push(newodds[i]);
    //   }

    }

  // const status = 200;
  // res.status(status);
  //   res.send(newodds);
  return newoddsupdated;
}
function foreach(arr, func){
  for(var i in arr){
    func(i, arr[i]);
  }
}
app.get('/testingdata',(req,res)=>{
  const fs = require('fs')
  let filename = '';
  if(req.query.sports==1){
    filename = 'Football';
  }
  if(req.query.sports==13){
    filename = 'Tennis';
  }
  if(req.query.sports==18){
    filename = 'Basketball';
  }
  if(req.query.sports==91){
    filename = 'Volleyball';
  }
  fs.readFile(filename+'.json', 'utf8' , (err, data) => {
  if (err) {
    console.error(err)
    return
  }
    res.send(data)
})
  // res.send({"name":"test"});
})

app.get('/export-sports',(req,res)=>{
//   MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
//   if (err) throw err;
//   var dbo = db.db("winpars_db");
//   dbo.collection("betradereachpush").find({"sport":req.query.sports}).toArray(function(err, result) {
//     if (err) throw err;
//     process_feed_to_exports_sports(result,req,res);
//     // res.send(result);
//
//     db.close();
//   });
// });
export_each_event("171555465");
})

async function exports_sports_data_tofile(sp) {
   
    let resultSet = await betradereachpush.find({"sport":sp});
    if(resultSet.length){
      process_feed_to_exports_sports(resultSet,sp);
      console.log(sp)
    }
}
setInterval(()=>{
  exports_sports_data_tofile('1');
  exports_sports_data_tofile('18');
  exports_sports_data_tofile('13');
  exports_sports_data_tofile('91');

},3000);

setInterval(()=>{
  //
  export_each_event_datas('1');
  export_each_event_datas('18');
  export_each_event_datas('13');
  export_each_event_datas('91');
},1000);

setInterval(function(){
  deleteFilesFromCache('1');
  deleteFilesFromCache('18');
  deleteFilesFromCache('13');
  deleteFilesFromCache('91');
},60000);
function look_subsription_table() {
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  if (err) throw err;
  var dbo = db.db("winpars_db");
  dbo.collection("subsriptionTable").find({}).toArray(function(err, result) {
    if (err) throw err;

    db.close();
  });
});
}
 async function export_each_event_datas(sports) {
  let eventIdlist = new Array();
  let result = await betradereachpush.find({"sport":sports})
    if(result.length){
      //odds push
      result.forEach((item, i) => {
        if(is_cancel_league(item.match.info.league) && weekend_allow(item.match.info)){
                      if(item.match.odds){
                        let odds = modify_markets('','',item.match.odds);
                        odds = JSON.stringify(odds);
                        if(odds){                                         
                           makepostreqviareqlib(odds,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',getSportsName(sports)+"/"+item.eventId+".json")
                           makepostreqviareqlibfordemo(odds,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',getSportsName(sports)+"/"+item.eventId+".json")
                           
                        }
                      }
                    }
      })

      //Stats
      result.forEach((item, i) => {
                    if(is_cancel_league(item.match.info.league) && weekend_allow(item.match.info)){
                    if(item.match.odds){
                      if(item.match.info.minute<0){
                        item.match.info.minute = 0;
                      }
                    let statsinfo ={"info":item.match.info,"stats":item.match.stats};
                    statsinfo = JSON.stringify(statsinfo);
                   
                      if(statsinfo){
                    makepostreqviareqlib(statsinfo,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',getSportsName(sports)+"/_stats/"+item.eventId+".json")
                    makepostreqviareqlibfordemo(statsinfo,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',getSportsName(sports)+"/_stats/"+item.eventId+".json")
                  }
                  }
                }
                });
        //  Full Events

        result.forEach((item, i) => {
            if(is_cancel_league(item.match.info.league) && weekend_allow(item.match.info)){
          if(item.match.odds){
            eventIdlist.push(item.eventId+".json");
            if(item.match.info.minute<0){
              item.match.info.minute = 0;
            }
            let statsinfo ={"info":item.match.info,"stats":item.match.stats,"core":item.match.core,"odds":item.match.odds};
            statsinfo = JSON.stringify(statsinfo);
            // fs.writeFile(getSportsName(sports)+"/_full/"+item.eventId+".json", statsinfo, function(err) {
            //     if(err) {
            //         return console.log(err);
            //     }
            //     console.log(item.eventId +" The Full file was saved!");
            // });
            if(statsinfo){
              makepostreqviareqlib(statsinfo,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',getSportsName(sports)+"/_full/"+item.eventId+".json")
              makepostreqviareqlibfordemo(statsinfo,'http://185.80.53.53/Feed_Process_data/FeedReceived.php',getSportsName(sports)+"/_full/"+item.eventId+".json")
            }

          }
        }
        });

    }else{

    }


}

function export_each_event_stats(sports) {
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  if (err) throw err;
  var dbo = db.db("winpars_db");
  dbo.collection("betradereachpush").find({"sport":sports}).toArray(function(err, result) {
    if (err) throw err;
    if(result.length>0){
        // res.send(result[0].match.odds);
        result.forEach((item, i) => {
          let statsinfo ={"info":item.match.info,"stats":item.match.stats};
          statsinfo = JSON.stringify(statsinfo);
          fs.writeFile(getSportsName(sports)+"/_stats/"+item.eventId+".json", statsinfo, function(err) {
              if(err) {
                  return console.log(err);
              }
              console.log(item.eventId +" The file was saved!");
          });
        });

      // const status = 200;
      // res.status(status);
      //   res.send(statsinfo);
    }

    // res.send(result);

    db.close();
  });
});

}
app.get('/test-data',(req,res)=>{

})

async function deleteFilesFromCache(sp) {

  let eventIdlist = new Array();
  let result = await betradereachpush.find({"sport":sp})
  if(result.length){
    console.log('Loop Start');
        result.forEach((item, i) => {
          eventIdlist.push(item.eventId+".json");

        });

        DeleteFromDir(eventIdlist,getSportsName(sp));
        console.log('Loop End');
  }

//   MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
//   if (err) throw err;
//   var dbo = db.db("winpars_db");
//   dbo.collection("betradereachpush").find({"sport":sp}).toArray(function(err, result) {
//     if (err) throw err;
//     if(result.length>0){
//         // res.send(result[0].match.odds);


//         console.log('Loop Start');
//         result.forEach((item, i) => {
//           eventIdlist.push(item.eventId+".json");

//         });

//         DeleteFromDir(eventIdlist,getSportsName(sp));
//         console.log('Loop End');

//     }else{

//     }
//     // res.send(result);

//     db.close();
//   });
// });




}

function DeleteFromDir(ActiveEvent,sp) {
  // ActiveEvent = new Array();
  const directoryPath = path.join(__dirname, sp);
  let filename = new Array();
  fs.readdir(directoryPath,function (err, files) {
      //handling error
      if (err) {
          return console.log('Unable to scan directory: ' + err);
      }
      //listing all files using forEach
      files.forEach(function (file) {
          if (path.extname(file) == ".json"){
          // Do whatever you want to do with the file
        if(ActiveEvent.indexOf(file)==-1){

            let mainpath = directoryPath+"/"+file;
            let statspath =directoryPath+"/_stats/"+file;
            let fullpath = directoryPath+"/_full/"+file;
            fs.unlink(mainpath,(err)=>{
                if(err){
                  console.log("Main Folder "+ err);
                }
            });
            fs.unlink(statspath,(err)=>{
                if(err){
                  console.log("statspath Folder "+ err);
                }
            });
            fs.unlink(fullpath,(err)=>{
                if(err){
                  console.log("fullpath Folder "+ err);
                }
            });
            console.log(file);
          }



        }

      });
      // res.send(JSON.stringify(filename));
  });
}
app.post('/subsription-match',(req,res)=>{
  // console.log('Got body:', req.body);
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
      if (err) throw err;
      var dbo = db.db("winpars_db");
    var resultdata = {
      "eventId":req.body.eventId
    }
    var myquery = { eventId: req.body.eventId };
    var newvalues = { $set: resultdata };
    dbo.collection("subscriptionTable").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
        if (err) throw err;
        // console.log("1 document updated");
        db.close();

    });
  });
  res.sendStatus(200);
});
app.get('/event-data',function(req,res){
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  if (err) throw err;
  var dbo = db.db("winpars_db");
  dbo.collection("betradereachpush").find({"eventId":req.query.eventId}).toArray(function(err, result) {
    if (err) throw err;
    // process_feed_new(result,req,res);
    if(result.length>0){
        // res.send(result[0].match.odds);

      let odds = modify_markets(req,res,result[0].match.odds);
      const status = 200;
      res.status(status);
        res.send(odds);
    }else{
      res.send({});
    }


    db.close();
  });
});
});
app.get('/event-stats',function(req,res){
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  if (err) throw err;
  var dbo = db.db("winpars_db");
  dbo.collection("betradereachpush").find({"eventId":req.query.eventId}).toArray(function(err, result) {
    if (err) throw err;
    // process_feed_new(result,req,res);
    if(result.length>0){
        // res.send(result[0].match.odds);

      let statsinfo ={"info":result[0].match.info,"stats":result[0].match.stats};
      const status = 200;
      res.status(status);
        res.send(statsinfo);
    }else{
      res.send({});
    }


    db.close();
  });
});
});
app.get('/event-details',function(req,res){
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  if (err) throw err;
  var dbo = db.db("winpars_db");
  dbo.collection("betradereachpush").find({"eventId":req.query.eventId}).toArray(function(err, result) {
    if (err) throw err;
    // process_feed_new(result,req,res);
    if(result.length>0){
        // res.send(result[0].match.odds);

      let statsinfo ={"info":result[0].match.info,"stats":result[0].match.stats,"core":result[0].match.core,"odds":result[0].match.odds};
      const status = 200;
      res.status(status);
        res.send(statsinfo);
    }else{
      res.send({});
    }


    db.close();
  });
});
});
app.get('/match-data',function(req,res){
  // res.send(req.query.sports);
  // req.query.sports

//   MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
//   if (err) throw err;
//   var dbo = db.db("winpars_db");
//   dbo.collection("betradereachpush").find({"sport":req.query.sports}).toArray(function(err, result) {
//     if (err) throw err;
//     process_feed_new(result,req,res);
//     // res.send(result);
//
//     db.close();
//   });
// });

  let filename = '';
  if(req.query.sports==1){
    filename = 'Football';
  }
  if(req.query.sports==13){
    filename = 'Tennis';
  }
  if(req.query.sports==18){
    filename = 'Basketball';
  }
  if(req.query.sports==91){
    filename = 'Volleyball';
  }
  fs.readFile(filename+'.json', 'utf8' , (err, data) => {
      if (err) {
        console.error(err)
        return
      }
    res.send(data)
  })

})
