var fs = require('fs');
var http = require('http');
// var https = require('https');

// var credentials = {
//   key: fs.readFileSync('/home/winpars/public_html/SSL/ssl.key'),
//   cert: fs.readFileSync('/home/winpars/public_html/SSL/ssl.pem')
// };
var express = require('express');
const compression = require('compression');
const zlib = require('zlib');
var app = express();
const betradereachpush = require('./models/Betradereachpush')
const betraderresults = require('./models/Betraderresults')
const betraderhtresults = require('./models/Betraderhtresults')
const subsriptionTable = require('./models/SubsriptionTable')
const betradereachpushraw = require('./models/Betradereachpushraw')
const Rawfeed = require('./models/Rawfeed')
const RawfeedAE = require('./models/RawfeedAE')
const mongoose = require("mongoose");
mongoose.set('strictQuery', false)
//const clusterURI = "mongodb+srv://mongouser:dbZCiED9F65gAbKc@cluster0.otpkk.mongodb.net/winpars_db?retryWrites=true&w=majority";
const clusterURI = "mongodb+srv://winpars:6FA6gPp7CRyFQ028@cluster1.2aesn.mongodb.net/winpars_db?retryWrites=true&w=majority";
const localURI = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/winpars_db";
mongoose.connect(localURI).then(()=>{
    console.log("Connection done");
}).catch((err)=>{
    console.log(err);
})
// app.use(compression({ filter: shouldCompress }))

const shouldCompress = (req, res) => {
  if (req.headers['x-no-compression']) {
    // Will not compress responses, if this header is present
    return false;
  }
  // Resort to standard compression
  return compression.filter(req, res);
};
app.use(compression({
  // filter: Decide if the answer should be compressed or not,
  // depending on the 'shouldCompress' function above
  filter: shouldCompress,
  level:6,
  // threshold: It is the byte threshold for the response
  // body size before considering compression, the default is 1 kB
  threshold: 2*1000
}));
var redis = require('redis');
var client = redis.createClient();
var MongoClient = require('mongodb').MongoClient;
var url = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/admin";
// your express configuration here

var httpsServer = http.createServer(app);
// var httpsServer = https.createServer(credentials, app);

// httpServer.listen(8080);
// httpsServer.listen(8443);
//
process.env['NODE_TLS_REJECT_UNAUTHORIZED'] = '0';
var port    = process.env.PORT || 5001;
httpsServer.listen(port, '185.80.54.5', function () {
  console.log('Server listening at port %d', port);
  // res.send("Welcome to Winpars");
});




function foreach(arr, func){
  for(var i in arr){
    func(i, arr[i]);
  }
}
app.get('/delete-finished-event',async(req,res)=>{
 

  var myquery = { eventId: req.query.eventId.toString()  }; 
  let response = await subsriptionTable.deleteOne(myquery);
  var r = await Rawfeed.deleteOne(myquery);
  var r = await betradereachpush.deleteMany(myquery);
  
  var myquery = { eventId: parseInt(req.query.eventId) }; 
  
   var r = await Rawfeed.deleteOne(myquery);
  var r = await betradereachpush.deleteMany(myquery);
  
  const status = 200;
  res.status(status);
  if(response.deletedCount){
   
            res.send({"message":"deleted"});
  }else{
    res.send({"message":"Item Not Found"});
  }
  
  
})
app.get('/fetch-active-events',async(req,res)=>{

  let result = await subsriptionTable.find({"sp":req.query.sp})
  const status = 200;
  res.status(status);
  if(result.length>0){   
    res.send(result);
  }else{
    res.send({});
  }

})
app.get('/fetch-ae-by-sp',async(req,res)=>{

  let result = await RawfeedAE.find({"sport":req.query.sp})
 
  const status = 200;
  res.status(status);
  if(result.length>0){   
    res.send(result);
  }else{
    res.send({});
  }

})
app.get('/event-data',async function(req,res){

    if(req.query.coltype=="MID"){
      let result = await betraderresults.find({"MID":parseInt(req.query.eventId)})
      const status = 200;
      res.status(status);
      if(result.length>0){                
               
            res.send(result);
        }else{
          res.send({});
        }
    }else{
      let result = await betraderresults.find({"matchId":parseInt(req.query.eventId)})
      const status = 200;
      res.status(status);
      if(result.length>0){                
               
            res.send(result);
        }else{
          res.send({});
        }

    }

});
app.get('/event-data-ht',async function(req,res){

    if(req.query.coltype=="MID"){
      let result = await betraderhtresults.find({"MID":parseInt(req.query.eventId)})
      const status = 200;
      res.status(status);
      if(result.length>0){                
               
            res.send(result);
        }else{
          res.send({});
        }
    }else{
      let result = await betraderhtresults.find({"matchId":parseInt(req.query.eventId)})
      const status = 200;
      res.status(status);
      if(result.length>0){                
               
            res.send(result);
        }else{
          res.send({});
        }

    }

});
