const mongoose = require("mongoose");
const market = require('./market.js');
var markets      = market.markets().market;
const Rawfeed = require('./models/Rawfeed');
const RawfeedAE = require('./models/RawfeedAE');
const localURI = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/winpars_db";
const remoteURI = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@193.42.38.197:27017/winpars_db"
//mongoose.set('strictQuery', false);
mongoose.connect(localURI).then(()=>{
    console.log("Connection done");
}).catch((err)=>{
    console.log(err);
})




async function save_live_raw_data(data){
  const filter = { eventId: data.ei };
    const update = {eventId:data.ei ,sport:data.sp,match:data};

    let eachpush = await Rawfeed.findOneAndUpdate(filter,update,{
      new : true,
      upsert : true
    })
}

async function save_live_raw_dataAE(data){
  const filter = { sport:data.sp};
    const update = {eventId:data.ei ,sport:data.sp,match:data};

    let eachpush = await RawfeedAE.findOneAndUpdate(filter,update,{
      new : true,
      upsert : true
    })
}
exports.process_raw_feed = function(feed){
    feed = JSON.parse(feed);
  if(feed.D=="UE"){
      if(feed.sp==1 || feed.sp==18 || feed.sp==13 || feed.sp==91){
          if(!feed.T1.n.includes("esports") && !feed.T1.n.includes("Reserves") && !feed.T1.n.includes("Esports")){
            //   var odds = makeOdds(feed);
              save_live_raw_data(feed);
       
      }
         
      }
  }
  if(feed.D=="AE"){
       if(feed.sp==1 || feed.sp==18 || feed.sp==13 || feed.sp==91){
            save_live_raw_dataAE(feed);
       }
  }
}